*+
*       hdbios.s
*
*       Ein- / Ausgaberoutinen fr Festplatte mit OMTI 5520A am DMA-Port
*
*        Das Programm ist positionsunabhngig enthlt aber eine Adresse die
*        reloziert werden kann, aber nicht mu ! (Dummyzugriff)
*        Das TOS mchte beim Laden jedenfalls etwas umrechnen: Bitteschn !
*
*
*        10.09.87   af  v0.1  - Lesen & Schreiben ohne DMA-Betrieb
*        21.09.87   af  v0.2  - Beim Initialisieren recalibrate mit 10 Sek.
*                               Timeout durchfhren
*        27.09.87   af  v0.3  - Lesen & Schreiben von mehr als 256 Sektoren
*                               zulassen
*        29.09.87   af  v0.4  - bei Lesen & Schreiben nach jedem Sektor 1 Sek.
*                               timeout, um evtl. alternative Spur anzufahren
*        29.09.87   af  v0.5  - Plattenparameter aus Bootsektor lesen und
*                               bergeben, Sektor- & Kopfanzahl fr rec_calc
*                               aus spt & nsides in Speicher ablegen
*        08.12.87   af  v0.6  - mit anderem Adapter DMA-Betrieb fr Lesen &
*                               Schreiben, Hard-Reset ber Portbit
*        22.12.87   af  v0.7  - Genderte Zuordnung der Laufwerksnummern und
*                               etwas Begrungstext ausgeben
*        18.01.88   af  v0.8  - Lese- & Schreibefunktion knnen durch 32-Bit-
*                               Argumente jetzt mehr als 32 MByte verwalten.
*                               Dadurch allerdings genderte Parameter !
*        16.03.88   af  v0.9  - verbesserte Fehlerrckmeldungen und Abbruch
*                               der Installierung bei Fehlern
*        09.04.88   af  v0.10 - Restaurieren des alten Stackinhalts nach Aufruf
*                               der Schreib-/Lesefunktion ( _rw )
*        19.04.88   af  v1.1  - Fr 'schrge Typen' jetzt mit bertragung von/
*                               auf ungerade Adressen.
*-
          text
          page
*       Einige Definitionen

drv_num   equ     '   C'-'   A'       ; erste Laufwerksnummer
gemdos    equ     1
cconout   equ     2                   ; Zeichenausgabe
cconws    equ     9                   ; Zeichenkette ausgeben
super     equ     $20                 ; Supervisormodus ein-/ausschalten
ptermres  equ     $31                 ; Programm resident verlassen
pterm     equ     $4c                 ; Programm normal verlassen
flock     equ     $43e                ; Variable zum sperren von FDC-Aktionen
_dskbufp  equ     $4c6                ; Zeiger auf 1k Diskbuffer
_hz_200   equ     $4ba                ; 200Hz Zhler
hdv_bpb   equ     $472                ; BPB holen
hdv_rw    equ     $476                ; Lesen-/Schreiben von Sektoren
hdv_med   equ     $47e                ; Test auf Mediumwechsel
_drvbits  equ     $4c2                ; Bitvektor fr angeschl. Laufwerke

fat_ind   equ     1                   ; Flag fr 16 Bit FAT Eintrge
steprate  equ     1                   ; 10 mikrosec.
* 0=  3ms, 1= 10us, 2= 25us, 3= 50us, 4=200us, 5= 70us, 6=  3ms, 7=  3ms

*       Adressen vom DMA-Chip u..

diskctl   equ     $ffff8604           ; Kontrollerzugriff/Sektorzhler
fifo      equ     $ffff8606           ; DMA-Steuerregister
dmahigh   equ     $ffff8609           ; DMA-Basis Register
dmamid    equ     $ffff860b
dmalow    equ     $ffff860d

gpip      equ     $fffffa01           ; MFP-Parallelport (IRQ-Port)

*       Befehle des OMTI 5520 Kontrollers

_recal    equ     1                   ; Spur Null anfahren
_read     equ     8                   ; Sektor(en) lesen
_write    equ     $a                  ; Sektor(en) schreiben
_init     equ     $c                  ; Laufwerksparameter setzen

*       etwas fr den Linker ...

          xdef    hd_read,hd_write,hd_init
          xdef    send_cmd,wait_req,wait_l,status
          xdef    super_on,superoff
          xdef    install,reset,hard_res

          page
*+
*       Festplattentreiber installieren und im Speicher halten
*-
basepage  set     4
text_seg  set     $c
data_seg  set     $14
bss_seg   set     $1c
*
main      move.l  basepage(sp),a0
          move.l  text_seg(a0),d7     ; Lnge Text-Seg. +
          add.l   data_seg(a0),d7     ; Lnge Data-Seg. +
          add.l   bss_seg(a0),d7      ; Lnge Bss-Seg.  +
          add.l   #$100,d7            ; Lnge Basepage  = Speicherbedarf

          clr     -(sp)               ; schon fr ptermres ...
          move.l  d7,-(sp)

          bsr     super_on
          lea     old_bpb,a0          ; Dies ist die absolute Adresse
          lea     old_bpb,a0          ; manchmal reicht eine auch nicht aus ..

          bsr     hard_res
          bsr     hd_recal            ; Spur Null anfahren

          pea     hello(pc)           ; eine kleine Begrung
          move    #cconws,-(sp)
          trap    #gemdos
          addq.l  #6,sp

          bsr     install             ; Laufwerksnummern ermitteln
          tst.l   d0
          bne     main_err            ; Fehler beim installieren
          bsr     set_vect            ; HD-Vektoren setzen
          bsr     superoff            ; zurck in Usermodus

          move    #ptermres,-(sp)     ; die anderen Parameter sind schon da !!!
          trap    #gemdos             ; jetzt hlt's uns fest ...

main_err  bsr     superoff
          addq.l  #6,sp               ; die Parameter fr ptermres mssen weg
          
          pea     abort(pc)
          move    #cconws,-(sp)       ; Abbruchmeldung ausgeben
          trap    #gemdos
          addq.l  #6,sp
          
          move    #-1,-(sp)
          move    #pterm,-(sp)        ; Programm 'normal' verlassen
          trap    #gemdos
          
          page
*+          
*       
*       alte Sprungvektoren fr Harddiskroutinen merken und die neuen setzen
*-
set_vect  lea     old_bpb(pc),a0
          move.l  hdv_bpb,(a0)
          move.l  hdv_rw,4(a0)
          move.l  hdv_med,8(a0)
          lea     _hdv_bpb(pc),a0
          move.l  a0,hdv_bpb
          lea     _hdv_rw(pc),a0
          move.l  a0,hdv_rw
          lea     _hdv_med(pc),a0
          move.l  a0,hdv_med
          rts
          
*+
*       Supervisormodus einschalten
*-
super_on  clr.l   -(sp)
          move    #super,-(sp)
          trap    #gemdos
          addq.l  #6,sp
          lea     save_ssp(pc),a0
          move.l  d0,(a0)             ; SSP merken
          rts

*+
*       Supervisormodus ausschalten
*-
superoff  move.l  save_ssp(pc),-(sp)  ; alten SSP zurck
          move    #super,-(sp)
          trap    #gemdos
          addq.l  #6,sp
          rts

          page
*+
*       Partitionen als Laufwerke einbinden und Plattenparameter bergeben
*-
spt       set     $18                 ; Sektoren / Spur
nsides    set     $1a                 ; Anzahl der Kpfe
drv_parm  set     $1ba                ; Zeiger auf Plattenparameter
p0_flg    set     $1c6                ; Partitionsflag ($1 vorh., $81 bootbar)
p0_id     set     $1c7                ; enthlt 'GEM', falls Part. fr TOS
p0_st     set     $1ca                ; log. Startsektor der Partition
p0_siz    set     $1ce                ; Anzahl der log. Sektoren
*
install   link    a6,#0
          movem.l d1-d3/a1-a2,-(sp)
          clr.l   -(sp)               ; recno.l
          move    #1,-(sp)
          move.l  _dskbufp,-(sp)
          clr     -(sp)
          bsr     hd_read             ; Bootsektor in Diskbuffer laden
          lea     12(sp),sp
          tst.l   d0
          bne     inst_err            ; Fehler beim Lesen !

          move.l  _dskbufp,a0
          pea     drv_parm(a0)
          bsr     hd_init             ; Laufwerksparameter bergeben
          addq.l  #4,sp

          clr     d0
          move.l  _dskbufp,a0
          lea     heads(pc),a1
          move.b  spt(a0),3(a1)       ; Sektoren / Spur fr rec_calc()
          move.b  nsides(a0),1(a1)    ; Anzahl der Kpfe       "

          lea     p_start(pc),a1
          move    #drv_num,d3         ; erste Laufwerksnummer
          moveq   #0,d0
          bset    d3,d0               ; Bit fr erstes Laufwerk
          moveq   #3,d1               ; max. Anzahl der Partitionen
scanpart  tst.b   p0_flg(a0)
          beq     nextpart            ; keine aktive Partition
          move.l  p0_flg(a0),d2
          and.l   #$ffffff,d2         ; D2 enthlt ID
          cmp.l   gem(pc),d2
          bne     nextpart            ; keine Partition fr TOS
          move.l  p0_st(a0),(a1)+     ; log. Startsektor
          move.l  p0_siz(a0),(a1)+    ; Partitionslnge
          or.l    d0,_drvbits         ; Part. als Laufwerk einbinden
          bsr     prt_drv
          lsl.l   #1,d0               ; nchstes Laufwerk
          addq    #1,d3
nextpart  add     #12,a0              ; Zeiger auf nchsten Partitionseintrag
          dbf     d1,scanpart
          subq    #1,d3
          lea     drives(pc),a0
          move    d3,(a0)             ; hchste Laufwerksnummer merken
          moveq.l #0,d0               ; kein Fehler
inst_err  movem.l (sp)+,d1-d3/a1-a2
          unlk    a6
          rts

*+
*       Zuordnung der Laufwerksnummern zu den Partitionen ausgeben
*          ( Ach, ist das in Assembler ein Aufwand ! )
*-
prt_drv   movem.l d0-d3/a0-a1,-(sp)

          pea     part_txt(pc)        
          move    #cconws,-(sp)
          trap    #gemdos
          addq.l  #6,sp

          not     d1
          and     #%11,d1             ; Partitionsnummer
          add.b   #'0',d1
          move    d1,-(sp)
          move    #cconout,-(sp)
          trap    #gemdos
          addq.l  #4,sp

          pea     drv_text(pc)
          move    #cconws,-(sp)
          trap    #gemdos
          addq.l  #6,sp

          add.b   #'a',d3             ; Laufwerksbuchstabe
          and     #$ff,d3
          move    d3,-(sp)
          move    #cconout,-(sp)
          trap    #gemdos
          addq.l  #4,sp

          pea     inst_txt(pc)
          move    #cconws,-(sp)
          trap    #gemdos
          addq.l  #6,sp
          
          movem.l (sp)+,d0-d3/a0-a1
          rts

          page
*+
*       Gewnschtes Laufwerk mit vorhandenen Partitionen vergleichen
*       und entsprechende Routine anspringen
*-
chk_driv  cmp     drives(pc),d0
          bhi     no_hd
          cmp     #drv_num,d0
          blo     no_hd
          jmp     (a1)                ; die Festplatte ist gemeint
no_hd     jmp     (a0)                ; alte Routine Anspringen

*+
*       Mediumwechsel mitteilen
*-
dev       set     4
*
_hdv_med  move    dev(sp),d0
          move.l  old_med(pc),a0
          lea     hd_med(pc),a1
          bra     chk_driv
*
hd_med    clr.l   d0                  ; ist halt eine Festplatte !
          rts     

          page
*+
*       Bios-Parameter-Block holen
*
*         Der BPB wird jedesmal neu aus dem Bootsektor der Partition errechnet
*-
dev       set     4
*
_hdv_bpb  move    dev(sp),d0
          move.l  old_bpb(pc),a0
          lea     hd_bpb(pc),a1
          bra     chk_driv
*
hd_bpb    sub     #drv_num,d0
          asl     #3,d0
          lea     p_start(pc),a0
          move.l  0(a0,d0),d0         ; ersten log. Sektor der Partition

          move.l  d0,-(sp)            ; Bootsektor der entsprechenden
          move    #1,-(sp)            ;   Partition in Diskbuffer laden
          move.l  _dskbufp,-(sp)
          clr     -(sp)
          bsr     hd_read             
          lea     12(sp),sp
          not.l   d0                  ; Fehlernummer 'umdrehen'
          beq     bpb_err             ; Lesefehler

          bsr     bpb_calc            ; BPB aus Bootsektor errechnen
          move.l  a0,d0
bpb_err   rts
          
*+ 
*       BPB aus Bootsektor Info errechnen
*
*       Wort-Werte sind im Bootsektor (leider) im Intel Format abgelegt !
*-
dev       set     8+3*4               ; drei Register werden noch gerettet
recsiz    set     0
clsiz     set     2
clsizb    set     4
rdlen     set     6
fsiz      set     8
fatrec    set     10
datrec    set     12
numcl     set     14
bflags    set     16
bps       set     $b
spc       set     $d
ndirs     set     $11
nsects    set     $13
spf       set     $16
*
bpb_calc  movem.l d1-d2/a1,-(sp)
          move.l  _dskbufp,a1
          lea     bpb(pc),a0          ; Zeiger auf ersten BPB
          move    dev(sp),d0          ; Laufwerksnummer
          ext.l   d0
          sub     #drv_num,d0
          asl     #5,d0               ; Laufwerksnummer * 32 = Offset 
          add.l   d0,a0
          move.b  bps+1(a1),d1
          asl     #8,d1
          or.b    bps(a1),d1
          move    d1,recsiz(a0)       ; Sektorgre
          move.b  spc(a1),d2
          ext     d2
          move    d2,clsiz(a0)        ; Sektoren/Cluster
          move.b  spf+1(a1),d0
          asl     #8,d0
          or.b    spf(a1),d0
          move    d0,fsiz(a0)         ; Sektoren/FAT
          addq    #1,d0
          move    d0,fatrec(a0)       ; Beginn der 2.FAT
          mulu    d2,d1
          move    d1,clsizb(a0)       ; Bytes/Cluster
          move.b  ndirs+1(a1),d0
          asl     #8,d0
          or.b    ndirs(a1),d0        ; Anzahl Directory-Eintrge
          asl     #5,d0               ; * 32 (Lnge eines Eintrags)
          ext.l   d0
          divu    recsiz(a0),d0       ; / Sektorlnge
          move    d0,rdlen(a0)        ; Sektoren/Directory
          add     fatrec(a0),d0
          add     fsiz(a0),d0
          move    d0,datrec(a0)       ; erster Datensektor
          move.b  nsects+1(a1),d1
          asl     #8,d1
          or.b    nsects(a1),d1
          sub     d0,d1               ; gesamte Sekt. - erstem Datensektor
          ext.l   d1
          divu    clsiz(a0),d1        ; / Clustergre
          move    d1,numcl(a0)        ; = Anzahl Datencluster
          move    #fat_ind,bflags(a0) ; Bitlnge der Eintrge in FAT (12/16)
          movem.l (sp)+,d1-d2/a1
          rts


          page
*+
*       Lesen-/Schreiben von Sektoren
*-
rwflag    set     4
count     set     10+8                ; zwei Reg. werden noch gerettet
recno     set     12+8
dev       set     14
*
_hdv_rw   move    dev(sp),d0
          move.l  old_rw(pc),a0
          lea     _rw(pc),a1
          bra     chk_driv
*
_rw       move    dev(sp),d0          ; Laufwerksnummer
          movem.l d1-d2,-(sp)         ; soll ja nichts umkommen
          moveq.l #0,d1
          moveq.l #0,d2
          move.l  recno(sp),d3        ; Sektor- & Laufwerksnummer retten
          tst     count(sp)
          beq     _rw_err             ; war wohl 'n Witz !
          move    recno(sp),d1        ; logischer Sektor
          lea     p_start(pc),a0
          sub     #drv_num,d0         ; Laufwerksnummer als Index
          asl     #3,d0               ; Eintrag ist Langwort*2
          cmp.l   4(a0,d0),d1         ; mit Partitionsgre vergl.
          bhs     _rw_err             ; das wr schon eine andere Partition !
          move    count(sp),d2
          add.l   d2,d1
          cmp.l   4(a0,d0),d1         ; mehr Sektoren als noch vorhanden ?
          bhi     _rw_err             ; das geht sonst in eine andere Partition
          sub.l   d2,d1
          add.l   0(a0,d0),d1         ; log. Sektor + Startsektor der Part.
          move.l  d1,recno(sp)        ; = physikalisch-logischer Sekt. ?!?!
          movem.l (sp)+,d1-d2

          move.l  (sp)+,a3            ; alte Rcksprungadresse holen
          pea     _rw_exit(pc)        ; Rcksprungadresse setzen (brutal)
          move    rwflag(sp),d0 
          and     #1,d0               ; ein 'Lesen mit ignorieren von Medium-
          tst     d0                  ; wechsel'(%10)  wre ein 'Schreiben' !!!
          bne     hd_write
          bra     hd_read

_rw_exit  move.l  d3,recno-12(sp)     ; Sektor- & Laufwerksnr. restaurieren
          jmp     (a3)                ; zurck zum Aufruf

_rw_err   movem.l (sp)+,d1-d2
          moveq.l #-1,d0
          rts

          page
*+
*       Lesen von Sektoren
*
*       hd_read(rwflag,buf,count,recno)
*         long buf,recno
*         word rwflag,count
*         ( rwflag wurde schon ausgewertet, dev wurde wegen Erweiterung
*           von recno auf 32-Bit zerstrt !)
*
*       Der gesamt bentigte Block wird in entsprechende 32-Sektoren-Blcke
*       und einen Block fr die verbleibenden Sektoren unterteilt, da der
*       DMA-Chip nur max. 59 (!?) Sektoren bedienen kann. (Zumindest meiner,
*       der Lohn fr die lange Experimentierphase)
*-
buf       set     10
count     set     14
recno     set     16
odd_flag  set     -2
blocks    set     32
*
hd_read   link    a6,#-2
          movem.l d1-d5/a2-a5,-(sp)
          lea     diskctl,a5
          lea     fifo,a4
          st      flock               ; Floppy VBL sperren
          move.l  recno(a6),d5
          move.l  buf(a6),a3
          moveq.l #0,d4
          move    count(a6),d4

          btst    #0,buf+3(a6)        ; Bufferadresse gerade ?
          beq     rd_even             ; ja !
          moveq.l #1,d3               ; nur einzelne Sektoren
          move.l  _dskbufp,a2         ; Adresse des Diskbuffers
          move    #1,odd_flag(a6)     ; DAS MERK ICH MIR !!!
          bra     rd_loop

rd_even   moveq.l #blocks,d3          ; max. Anzahl der Sektoren
          divu    #blocks,d4
          move.l  a3,a2               ; Bufferadr.
          clr     odd_flag(a6)        ; damit alles gerade geht ...
          bra     rd_loop

rd_block  move    #steprate,-(sp)     ; Kontroll-Byte
          clr     -(sp)
          move.b  d3,1(sp)            ; Sektorzhler
          move.l  d5,d0
          bsr     rec_calc            ; log. Sektor -> Zylinder, Kopf, Sektor
          movem   d0-d2,-(sp)
          move    #_read,-(sp)
          bsr     send_dma            ; DMA-Kommando senden
          lea     12(sp),sp
          tst     d0
          bne     rd_err

          bsr     mask
          move    #3,(a5)             ; IRQ- & DMA-Maske setzen
          move    #$ca,(a4)
          move    #$4,(a5)            ; DMA-Richtung: lesen

          move.l  a2,-(sp)
          bsr     set_dma             ; bertragungsadresse setzen
          addq.l  #4,sp

          move    #$98,(a4)           ; DMA-Status lschen und bertragungs-
          move    #$198,(a4)          ;            richtung auf Lesen setzen
          move    #$98,(a4)

          clr     d0
          move.b  d3,d0
          move    d0,(a5)             ; Blockzhler fr DMA-Chip

          move    #$8,(a4)            ; bertragung starten
          bsr     wait_dma            ; auf IRQ warten
          bne     rd_err
          bsr     mask
          move    #0,(a5)             ; IRQ- & DMA-Maske lschen
          bsr     status              ; Statusbyte lesen
          tst.l   d0
          bne     rd_err

          tst     odd_flag(a6)
          bne     rd_odd
          bsr     get_dma             ; DMA-Endadresse holen
          move.l  d0,a2
          bra     rd_loop1

rd_odd    pea     (a3)                ; Zieladresse
          pea     (a2)                ; Quelladresse
          bsr     sectcopy            ; Block kopieren
          addq.l  #8,sp
          lea     512(a3),a3          ; Zieladresse erhhen

rd_loop1  add.l   d3,d5               ; = Startsektor des nchsten Blocks
rd_loop   subq    #1,d4
          bge     rd_block            ; noch nicht alle 32-Sektor-Blcke ?
          cmp     #-1,d4              ; alle Blcke gelesen ?
          blo     rd_ok

          swap    d4
          tst     d4
          beq     rd_ok
          move    d4,d3               ; restliche Sektoren lesen
          swap    d4
          bra     rd_block

rd_ok     moveq.l #0,d0               ; Flag fr kein Fehler
rd_err    move    #$80,(a4)           ; DMA wieder auf Floppy
          sf      flock               ; Floppy VBL freigeben
          movem.l (sp)+,d1-d5/a2-a5
          unlk    a6
          rts

          page
*+
*       Schreiben von Sektoren
*
*       hd_write(rwflag,buf,count,recno)
*         long buf,recno
*         word rwflag,count
*         ( rwflag wurde schon ausgewertet, dev wurde wegen Erweiterung
*           von recno auf 32-Bit zerstrt !)
*
*       Der gesamt bentigte Block wird in entsprechende 32-Sektoren-Blcke
*       und einen Block fr die verbleibenden Sektoren unterteilt, da der
*       DMA-Chip nur max. 59 (!?) Sektoren bedienen kann. (Zumindest meiner,
*       der Lohn fr die lange Experimentierphase)
*-
buf       set     10
count     set     14
recno     set     16
odd_flag  set     -2
blocks    set     32
*
hd_write  link    a6,#-2
          movem.l d1-d5/a2-a5,-(sp)
          lea     diskctl,a5
          lea     fifo,a4
          st      flock               ; Floppy VBL sperren
          move.l  recno(a6),d5
          move.l  buf(a6),a3
          moveq.l #0,d4
          move    count(a6),d4

          btst    #0,buf+3(a6)        ; Bufferadresse gerade ?
          beq     wr_even             ; ja !
          moveq.l #1,d3               ; nur einzelne Sektoren
          move    #1,odd_flag(a6)     ; DAS MERK ICH MIR !!!
          bra     wr_loop

wr_even   moveq.l #blocks,d3          ; max. Anzahl der Sektoren
          divu    #blocks,d4
          move.l  a3,a2               ; Bufferadr.
          clr     odd_flag(a6)        ; damit alles gerade geht ...
          bra     wr_loop

wr_block  move    #steprate,-(sp)     ; Kontroll-Byte
          clr     -(sp)
          move.b  d3,1(sp)            ; Sektorzhler
          move.l  d5,d0
          bsr     rec_calc            ; log. Sektor -> Zylinder, Kopf, Sektor
          movem   d0-d2,-(sp)
          move    #_write,-(sp)
          bsr     send_dma            ; DMA-Kommando senden
          lea     12(sp),sp
          tst     d0
          bne     wr_err

          bsr     mask
          move    #3,(a5)             ; IRQ- & DMA-Maske setzen
          move    #$ca,(a4)
          move    #$0,(a5)            ; DMA-Richtung: schreiben

          tst     odd_flag(a6)
          beq     wr_odd              ; Transfer von gerader Adresse
          move.l  _dskbufp,a2         ; Sektorbuffer
          pea     (a2)                ; Zieladresse
          pea     (a3)                ; Quelladresse
          bsr     sectcopy            ; Block kopieren
          addq.l  #8,sp
          lea     512(a3),a3          ; Quelladresse erhhen
          
wr_odd    move.l  a2,-(sp)
          bsr     set_dma             ; bertragungsadresse setzen
          addq.l  #4,sp


          move    #$198,(a4)          ; DMA-Status lschen und bertragungs-
          move    #$98,(a4)           ;        richtung auf Schreiben setzen
          move    #$198,(a4)

          clr     d0
          move.b  d3,d0
          move    d0,(a5)             ; Blockzhler fr DMA-Chip

          move    #$108,(a4)          ; bertragung starten
          bsr     wait_dma            ; auf IRQ warten
          bne     wr_err
          bsr     mask
          move    #0,(a5)             ; IRQ- & DMA-Maske lschen
          bsr     status              ; Statusbyte lesen
          tst.l   d0
          bne     wr_err

          bsr     get_dma             ; DMA-Endadresse holen
          move.l  d0,a2

          add.l   d3,d5               ; = Startsektor des nchsten Blocks
wr_loop   subq    #1,d4
          bge     wr_block            ; noch nicht alle 32-Sektor-Blcke ?
          cmp     #-1,d4              ; alle Blcke geschrieben ?
          blo     wr_ok

          swap    d4
          tst     d4
          beq     wr_ok
          move    d4,d3               ; restliche Sektoren schreiben
          swap    d4
          bra     wr_block

wr_ok     moveq.l #0,d0               ; Flag fr kein Fehler
wr_err    move    #$80,(a4)           ; DMA wieder auf Floppy
          sf      flock               ; Floppy VBL freigeben
          movem.l (sp)+,d1-d5/a2-a5
          unlk    a6
          rts

          page
*+
*
*+
*       logischen Sektor in Zylinder, Kopf und Sektor umrechnen
*
*       rec_calc(d0)
*         -> D0.b = Kopf
*            D1.b = Sektor
*            D2.b = Zylinder
*-
rec_calc  divu    sectors(pc),d0
          swap    d0
          move    d0,d1               ; Sektor
          clr     d0
          swap    d0
          divu    heads(pc),d0        ; d0.w = C0-C9
          move.b  d0,d2               ; Zylinder C0-C7
          and     #$ff,d2
          clr.b   d0
          lsr     #2,d0               ; Zylinder C8-C9
          or.b    d0,d1               ; Sektor .oder C8-C9
          swap    d0                  ; Kopf
          rts

*+
*       DMA-Adresse setzen
*-
set_dma   move.b  7(sp),dmalow
          move.b  6(sp),dmamid
          move.b  5(sp),dmahigh
          rts

*+
*       DMA-Adresse holen
*-
get_dma   clr.l   -(sp)
          move.b  dmalow,3(sp)
          move.b  dmamid,2(sp)
          move.b  dmahigh,1(sp)
          move.l  (sp)+,d0
          rts

          page
*+
*       Blockverschieberoutine fr einen Sektor (512 Bytes)
*
*       sectcopy (source,destination)
*         long source,destination
*-
sectcopy  move.l  4(sp),a0            ; Quelladresse
          move.l  8(sp),a1            ; Zieladresse
          moveq.l #63,d0              ; 64 * 8 = 512   (?!?)

copyloop  move.b  (a0)+,(a1)+         ; 8 Bytes verschieben
          move.b  (a0)+,(a1)+
          move.b  (a0)+,(a1)+
          move.b  (a0)+,(a1)+
          move.b  (a0)+,(a1)+
          move.b  (a0)+,(a1)+
          move.b  (a0)+,(a1)+
          move.b  (a0)+,(a1)+
          dbra    d0,copyloop
          rts

          page
*+
*       Laufwerk auf Spur Null fahren und max. 10 Sekunden warten
*         Nach einem Reset wird der erste Seek-Vorgang mit niedrigster
*         Steprate durchgefhrt wobei es bis zu 10 Sek. dauern kann, falls
*         der Kopf auf einer hohen Zylindernummer (evtl. Parkzone) steht.
*
*         hd_recal()
*-
hd_recal  link    a6,#0
          movem.l d1-d3/a4-a5,-(sp)
          lea     diskctl,a5
          lea     fifo,a4
          st      flock               ; Floppy VBL sperren
          bsr     reset               ; Kontroller rcksetzen

          move    #steprate,-(sp)
          clr.l   -(sp)
          clr.l   -(sp)
          move    #_recal,-(sp)
          bsr     send_cmd
          add.l   #12,sp
          move.l  #2000,d1            ; 10 Sek. timeout
          bsr     wait_l
          bsr     status              ; Statusbyte lesen

recal_er  move    #$80,(a4)           ; DMA wieder auf Floppy
          sf      flock               ; Floppy VBL freigeben
          movem.l (sp)+,d1-d3/a4-a5
          unlk    a6
          rts

          page
*+
*       Laufwerksparameter setzen
*
*         hd_init(param)
*           long param
*-
param     set     8
*
hd_init   link    a6,#0
          movem.l d1-d3/a4-a5,-(sp)
          lea     diskctl,a5
          lea     fifo,a4
          st      flock               ; Floppy VBL sperren
          bsr     reset               ; Kontroller rcksetzen

          clr.l   -(sp)
          clr.l   -(sp)
          clr     -(sp)
          move    #_init,-(sp)
          bsr     send_cmd
          bne     init_err            ; -> timeout
          add.l   #12,sp

          clr     d0
          move.l  param(a6),a0        ; Zeiger auf Parametertabelle
          move    #7,d3               ; Bytezhler
ini_byte  bsr     wait_req
          bne     init_err            ; -> timeout
          move.b  (a0)+,d0
          move    d0,(a5)
          dbf     d3,ini_byte
          bsr     status              ; Statusbyte lesen

init_err  move    #$80,(a4)           ; DMA wieder auf Floppy
          sf      flock               ; Floppy VBL freigeben
          movem.l (sp)+,d1-d3/a4-a5
          unlk    a6
          rts

          page
*+
*       Kommando an Kontroller bertragen
*
*       send_cmd(cmd,head,sec,cyl,count,contrl)
*         word cmd,head,sec,cyl,count,contrl
*
*         -> timeout : D0.l = -1
*            ok      : D0.l = 0
*-
send_cmd  link    a6,#0
          movem.l d1-d2/a3-a5,-(sp)
          lea     diskctl,a5
          lea     fifo,a4
          bsr     select              ; Kontroller selektieren

          moveq   #5,d2               ; Anzahl Datenbytes (=6)
          lea     8(a6),a3            ; Zeiger auf Parameter

scmd      bsr     wait_req
          bne     scmd_end            ; Zeitbegrenzung berschritten
          move    (a3)+,(a5)          ; Kommando bzw. Parameter
          dbra    d2,scmd
          move.l  #400,d1             ; 2.0 Sek warten
          bsr     wait_l
          bne     scmd_end
          clr.l   d0

scmd_end  tst     d0
          movem.l (sp)+,d1-d2/a3-a5
          unlk    a6
          rts

          page
*+
*       DMA-Kommando an Kontroller bertragen
*
*       send_cmd(cmd,head,sec,cyl,count,contrl)
*         word cmd,head,sec,cyl,count,contrl
*
*         -> timeout : D0.l = -1
*            ok      : D0.l = 0
*-
send_dma  link    a6,#0
          movem.l d1-d2/a3-a5,-(sp)
          lea     diskctl,a5
          lea     fifo,a4
          bsr     select              ; Kontroller selektieren

          moveq   #5,d2               ; Anzahl Datenbytes (=6)
          lea     8(a6),a3            ; Zeiger auf Parameter

sdma      bsr     wait_req
          bne     sdma_end            ; Zeitbegrenzung berschritten
          move    (a3)+,(a5)          ; Kommando bzw. Parameter
          dbra    d2,sdma
          clr.l   d0

sdma_end  tst     d0
          movem.l (sp)+,d1-d2/a3-a5
          unlk    a6
          rts

          page

*+
*       Auf bertragungsanforderung warten
*
*         wait_req: max. 1/10 Sekunde warten
*         wait_l:   max. D1.l * 1/200 Sekunden warten
*
*         -> timeout : D0.l = -1
*            ok      : D0.l = 0
*-
wait_req  move.l  #20,d1              ; 1/10 sec
wait_l    bsr     st_port             ; Statusport anwhlen
          add.l   _hz_200,d1
_wait     move    (a5),d0
          and     #1,d0               ; REQ-Bit testen
          bne     wait_ok             ; gesetzt = NE
          cmp.l   _hz_200,d1          ; Zeit abgelaufen ?
          bne     _wait
          bsr     d_port              ; Datenport anwhlen
          moveq.l #-1,d0
          rts

wait_ok   bsr     d_port              ; Datenport anwhlen
          clr.l   d0
          rts

*+
*       Auf DMA-bertragung warten
*
*         wait_dma: max. 1 Sekunde warten
*         wait_ld:  max. D1.l * 1/200 Sekunden warten
*
*         -> timeout : D0.l = -1
*            ok      : D0.l = 0
*-
wait_dma  move.l  #200,d1             ; 1 sec
wait_ld   add.l   _hz_200,d1
_waitd    btst    #5,gpip             ; IRQ testen
          beq     dma_ok              ; Hurra, er ist da !
          cmp.l   _hz_200,d1          ; Zeit abgelaufen ?
          bne     _waitd
          bsr     reset               ; Kontroller rcksetzen
          moveq.l #-1,d0
          rts

dma_ok    clr.l   d0
          rts

          page
*+
*       Hard-Reset durch setzen der Reset-Leitung
*-
hard_res  st      flock
          move    #100,d0             ; => ~ 125 mikrosek. Verzgerung
          move    #$ca,fifo
          move    #$80,diskctl        ; Reset-Leitung setzen ...
res_loop  dbra    d0,res_loop
          move    #0,diskctl          ; ... und zurcksetzen
          move    #$c8,fifo
res_lp    dbra    d0,res_lp           ; Verzgerung, damit der OMTI den Reset
          sf      flock               ;             in Ruhe verarbeiten kann.
          rts

*+
*       Statusbyte lesen
*-
status    bsr     wait_req
          move    (a5),d0             ; Fehlerbyte lesen
          and.l   #$ff,d0
          tst.l   d0
          beq     stat_ok             ; kein Fehler aufgetreten
          moveq.l #-1,d0              ; Fehlernummer
stat_ok   rts

*+
*       Kontroller rcksetzen (Soft-Reset)
*-
reset:    bsr     st_port
          move    #0,diskctl
          bra     d_port

          page
*+
*       Kontroller selektieren
*-
select    bsr     sel_port
          move    #0,diskctl          ; Selectport beschreiben (= Select)
          bra     d_port

*+
*       Datenport whlen
*-
d_port    move    #$ca,fifo
          move    #0,diskctl
          move    #$c8,fifo
          rts

*+
*       Status-/Resetport whlen
*-
st_port   move    #$ca,fifo
          move    #1,diskctl
          move    #$c8,fifo
          rts

*+
*       Konfigurations-/Selectport whlen
*-
sel_port  move    #$ca,fifo
          move    #2,diskctl
          move    #$c8,fifo
          rts

*+
*       DMA/INT-Maskenport whlen
*-
mask      move    #$ca,fifo
          move    #3,diskctl
          move    #$c8,fifo
          rts

          page
*+
*       Datenbereich
*-
hello     dc.b    13,10,'Festplattentreiber v1.1 fr OMTI-Kontroller'
          dc.b    13,10,10,0
          even
part_txt  dc.b    'Partition ',0,0
drv_text  dc.b    ' als Laufwerk ',0,0
inst_txt  dc.b    ': installiert',13,10,0
          even
abort     dc.b    13,10,'Festplatte konnte nicht korrekt angesprochen werden !'
          dc.b    13,10,'Installierung wird abgebrochen !',13,10,0
          even
gem       dc.b    0,'GEM'             ; ID fr TOS-Partition
heads     dc.w    1                   ; Anzahl der Kpfe (wird initialisiert)
sectors   dc.w    1                   ; Anzahl der Sektoren/Spur     "
save_ssp  ds.l    1                   ; Zwischenspeicher fr SSP
old_bpb   ds.l    1                   ; Platz fr die alten Vektoren
old_rw    ds.l    1
old_med   ds.l    1
drives    ds.w    1                   ; hchstes Laufwerk
p_start   ds.l    8                   ; Platz fr Startsektoren
bpb       ds.l    32                  ; Platz fr 4 BPB's


