/*
      hdformat.c
                  Festplattenformatierer fr OMTI-Kontroller

      Das Programm mu mit 'cbind' und 'hdbios' gelinkt werden

      16.01.88   v1.1
      15.03.88   v1.2
*/

#include <stdio.h>
#define lf 10

extern hard_res(),reset();           /* fr einige Linker */
extern hd_bufwr(),hd_init();
extern super_on(),superoff();
extern h_write();
extern hd_form(),hdassign();

int interl,cyl,heads,reduced,precomp,sectors,parkcyl;
char buffer[512];
char param[8];


main()
{
   int err,c;

   start();
   if(request())
   {
      printf("    Jetzt gibt es 3 Minuten Tee-Pause !\n");
      hd_reset();
      init();
      fill_buf();
      err=format();
      if(err != 0)
      {
         puts("    ** Fehler beim Formatieren aufgetreten !");
         puts("    Weiter mit <RETURN>");
         while ((c=getchar()) != '\n');
         while ((c=getchar()) != '\n');

         exit(err);
      }
      else
         printf("    Formatierung ok.\n");
      err=assign_bad();
      if(err)
         wrt_boot();
   }
}

start()        /*  Laufwerksparameter erfragen  */
{
   int c;

   puts("\n");
   puts("    Festplattenformatierer fr PC/XT-Kontroller");
   puts("    Version 1.2                                ");
   puts("    ===========================================\n");
   puts("    Bei einigen der folgenden Fragen sind mgliche Zahlenwerte");
   puts("    in eckigen Klammern angegeben. 'max. Zyl.' bedeutet dabei");
   puts("    Nummer des hchsten Zylinders.");
   puts("    Alle Angaben sind aber auch in den Handbchern zu finden !");
   puts("    ( Es ist brigens sinnvoll sich VORHER nochmals mit der");
   puts("      Literatur vertraut zu machen !!!                      )\n");
   printf("    Soll formatiert werden ? (j/n) ");
   if((c=getchar()) != 'j')
      exit();
   printf("\n    Anzahl der Zylinder (= max. Zyl.): ");
   scanf("%d",&cyl);
   printf("    Anzahl der Kpfe : ");
   scanf("%d",&heads);
   printf("    verringerter Schreibstrom ab Zylinder [ max. Zyl. ] : ");
   scanf("%d",&reduced);
   printf("    Schreibprekompensation ab Zylinder [ max. Zyl. ] : ");
   scanf("%d",&precomp);
   printf("    Sektorversatz [ 1 ] : ");
   scanf("%d",&interl);
   printf("    Sektoren pro Spur [ MFM: 17 ,RLL: 26 ] : ");
   scanf("%d",&sectors);
   printf("    Parkzylinder [ max. Zyl. + 1 ] : ");
   scanf("%d",&parkcyl);
}

request()         /*  Sicherheitsabfrage  */
{
   int c;

   while((c=getchar()) != lf);
   printf("\n    Soll wirklich formatiert werden ? (j/n) ");
   return((c=getchar())=='j');
}

fill_buf()        /*  Kontrollerbuffer mit Nullen fllen  */
{
   int i;

   for(i=0;i<512;i++)
      buffer[i]=0;
   super_on();
   hd_bufwr(&buffer);
   superoff();
}

hd_reset()
{
   super_on();
   hard_res();
   superoff();
}

format()
{
   int err;

   super_on();
   err=hd_form(interl);
   superoff();
   return(err);
}

init()
{
   put_param();
   super_on();
   hd_init(&param);
   superoff();
}

put_param()    /* Plattenparameter in Bytefeld bertragen */
{
   param[0]=cyl >> 8;
   param[1]=cyl & 0xff;
   param[2]=heads;
   param[3]=reduced >> 8;
   param[4]=reduced & 0xff;
   param[5]=precomp >> 8;
   param[6]=precomp & 0xff;
   param[7]=0;
}

assign_bad()       /*  fr fehlerhafte Spuren am Ende der Platte
                       Ersatzspuren zuweisen                        */
{
   int c,err,ohead,ocyl,nhead,ncyl;

   err=0;
   nhead=heads-1;
   ncyl=cyl-1;
   while((c=getchar()) != lf);
   printf("\n    fehlerhafte Spuren ? (j/n) ");
   while((c=getchar())=='j')
   {
      printf("    Zylinder : ");
      scanf("%d",&ocyl);
      printf("    Kopf : ");
      scanf("%d",&ohead);
      fill_buf();
      super_on();
      err=hdassign(ohead,ocyl,nhead,ncyl,interl);
      if(err != 0)
         printf("    ** Fehler bei Ersatzspurzuweisung !\n");
      superoff();

      if((nhead -= 1) < 0)
      {
         ncyl -= 1;
         nhead = heads-1;
      }  
      while((c=getchar()) != lf);
      printf("\n    mehr Eintrge ? (j/n) ");
   }
}

wrt_boot()    /*  Alle Laufwerksparameter in Bootsektor schreiben  */
{
   int i;

   for(i=0;i<512;i++)
      buffer[i]=0;

   for(i=0;i<8;i++)
      buffer[i+0x1ba]=param[i];           /* Plattenparameter in Bootsektor */

   buffer[0x18]=sectors;                  /* Anzahl Sektoren/Spur */
   buffer[0x1a]=heads;                    /* Anzahl der Kpfe */
   buffer[0x1c3]=(heads*cyl*sectors)>>16; /* Anzahl der Sektoren */
   buffer[0x1c4]=(heads*cyl*sectors)>>8 &0xff;
   buffer[0x1c5]=(heads*cyl*sectors)&0xff;
   buffer[0x1b8]=parkcyl>>8;
   buffer[0x1b9]=parkcyl&0xff;
   super_on();
   h_write(0,buffer,1,0,0);
   superoff();
}

