*+
*      hdpark.s
*
*         ACCESSORY zum Parken der Harddisk am OMTI-Controller
*
*         Sollte mit 'HDBIOS' gelinkt werden und als .ACC-File
*         abgespeichert werden.
*         
*         18.04.88 (tk)  
*
*         Assembler: AS68
*-

*   Diverse AES-Opcodes

APPL_INIT     equ   10                  
APPL_EXIT     equ   19
EVNT_MESAG    equ   23                  
MENU_REGISTER equ   35
FORM_ALERT    equ   52
GRAF_MOUSE    equ   78

AC_OPEN       equ   40                 
ARROW         equ   0
BEE           equ   2

*   Diverse Konstanten

_seek     equ       $0b                 ; Laufwerk positionieren
steprate  equ       1
park_cyl  equ       $1b8                ; Zeiger auf Wert der Parkspur
drv_parm  equ       $1ba                  

flock     equ       $43e                ; zum Sperren von FDC-Aktionen
diskctl   equ       $ffff8604           ; Kontrollerzugriff / Sektorzhler

          xref    super_on
          xref    superoff
          xref    hd_read
          xref    hd_init
          xref    hd_recal
          xref    send_cmd
          xref    status
          xref    wait_l

          text

*+
*    Accessory meldet sich beim GEM an, trgt sich in die 
*    Menuliste ein und wartet dann in einer Endlosschleife, 
*    bis es aufgerufen wird.
*-
main:     lea       base,sp             ; Platz fr eigenen Stack
          bsr       a_init              ; Anwendung anmelden
          lea       ac_str,a1           ; Accessory-Name, Nummer in D0
          bsr       menu_reg            ; in Menuliste eintragen
          lea       menu_id,a0
          move.w    d0,(a0)
loop:     lea       msgbuf,a1           ; Adresse des Buffers laden
          bsr       evnt_msg
          lea       msgbuf,a1 
          cmp.w     #AC_OPEN,(a1)       ; Wurde Accessory aufgerufen ?     
          bne.s     loop
          lea       menu_id,a0 
          move.w    (a0),d0 
          cmp.w     8(a1),d0            ; Richtige Menu_ID ? 
          bne.s     loop 
tu_was:   lea       string,a1           ; Alertbox ausgeben
          move.w    #2,d0               ; Default = 'ABBRUCH'
          bsr       alert
          cmp       #1,d0               ; 'OK' angeklickt ?
          bne.s     loop                ; nein, warten 
park:     bsr       hd_park
          lea       goodbye,a1          ; Goodbye-Message
          move.w    #0,d0               ; Kein Default
          bsr       alert 
          move      #BEE,d0             ; Es wurde 'DESKTOP' angeklickt   
          bsr       mouse_form          ; Mauszeiger ndern
          jsr       super_on
          jsr       hd_recal            ; Platte rekalibrieren
          jsr       superoff
          move      #ARROW,d0
          bsr       mouse_form
          bra       loop                ; Endlosschleife

hd_park:  movem.l   a5,-(sp)
          jsr       super_on
          bsr       readboot
          lea       buffer,a5
          move      drv_parm(a5),-(sp)  ; max. Anzahl der Zyl. merken ... 
          move      park_cyl(a5),d0
          addq      #1,d0               ; Anzahl der Zyl. = Parkzyl. + 1
          move      d0,drv_parm(a5)
          pea       drv_parm(a5)
          jsr       hd_init
          addq.l    #4,sp

          lea       buffer,a5
          moveq     #0,d0
          move      park_cyl(a5),d0     ; dies ist endlich der Parkzylinder
          bsr       hd_seek             ; nichts wie hin !

          move      (sp)+,drv_parm(a5)
          pea       drv_parm(a5)
          jsr       hd_init
          addq.l    #4,sp

hd_end:   jsr       superoff
          movem.l   (sp)+,a5
          rts

*+
*       Kleinere Unterprogramme
*-

*       Bootsektor in Buffer laden

readboot  clr.l     -(sp)               ; Sektor 0, Track 0, Kopf 0
          move      #1,-(sp)            ; Blockzhler
          pea       buffer
          clr       -(sp)
          jsr       hd_read
          lea       12(sp),sp
          rts

*+
*       Laufwerk auf Spur positionieren
*         Spur in D0.W
*-
hd_seek   movem.l   d1-d3/a4-a5,-(sp)
          lea       diskctl,a5
          lea       2(a5),a4
          st        flock               ; Floppy VBL sperren

          move      #steprate,-(sp)
          clr       -(sp)               ; Blockzhler
          clr.l     -(sp)
          move.b    d0,3(sp)            ; Cyl. %%7 - %%0
          clr.b     d0
          lsr       #2,d0
          move.b    d0,1(sp)            ; Cyl. %%9 - %%8
          clr       -(sp)
          move      #_seek,-(sp)
          jsr       send_cmd
          lea       12(sp),sp
          move.l    #10*200,d1          ; 10 Sek. timeout
          jsr       wait_l
seek_err  move      #$80,(a4)           ; DMA wieder auf Floppy
          sf        flock               ; Floppy VBL freigeben
          movem.l   (sp)+,d1-d3/a4-a5
          rts

*+
*         AES-Routine ausfhren:
*-
aes:      move.l    #AESPB,D1           ; Adresse des AES Parameterblocks
          move.w    #$C8,D0             ; AES Aufrufcode
          trap      #2                  ; GEM-Call
          rts

*+
*     Applikation beim GEM anmelden
*     Returnwert:
*         D0.W: ap_id oder -1 bei Fehler
*-
a_init:   move.l    a0,-(sp)
          lea       control,a0          ; Adresse des cntrl-Arrays
          move.w    #APPL_INIT,(a0)+    ; anmelden
          move.w    #0,(a0)+         
          move.w    #1,(a0)+ 
          move.w    #0,(a0)+ 
          move.w    #0,(a0)+ 
          bsr       aes    
          lea       int_out,a0
          move.w    (a0),d0             ; Returnwert in D0
          move.l    (sp)+,a0
          rts 

*+
*    Namen in der Accessory-Leiste eintragen
*    und Auswertung vornehmen
*         A1.L: Adresse des Menustrings
*         D0.W: AP_ID
*    Returnwert:
*         D0.W: Eintragskennung (0-5)
*-
menu_reg: move.l    a0,-(sp)
          lea       control,a0          ; Adresse des cntrl-Arrays
          move.w    #MENU_REG,(a0)+     ; cntrl(0) = Menu_Register
          move.w    #1,(a0)+
          move.w    #1,(a0)+
          move.w    #1,(a0)+
          move.w    #0,(a0)+
          lea       int_in,a0           ; int_in[0] eintragen
          move.w    d0,(a0)
          lea       addr_in,a0          ; ACCESSORY-Name in
          move.l    a1,(a0)             ; addr_in[0] eintragen
          bsr       aes
          move.l    (sp)+,a0
          rts

*+
*    Warten, bis eine EVENT_MESSAGE im 
*    Ereignisbuffer vorliegt
*         A1.L: Adresse von msgbuffer[8]  (8 Worte)
*-
evnt_msg: movem.l   a0-a1,-(sp)
          lea       control,a0
          move.w    #EVNT_MESAG,(a0)+
          move.w    #0,(a0)+
          move.w    #1,(a0)+
          move.w    #1,(a0)+
          move.w    #0,(a0)+
          lea       addr_in,a0
          move.l    a1,(a0)             ; Bufferadresse nach addr_in[0]
          bsr       aes
          movem.l   (sp)+,a0-a1
          rts

*+
*    ALERTBOX auf den Bildschirm zaubern:
*         A1.L: Die Adresse des Strings
*         D0.W: Der Default-Knopf
*    Returnwert: 
*         D0.W: Gedrckter Knopf
*- 
alert:    movem.l   a0-a1,-(sp)
          lea       control,a0         
          move.w    #FORM_ALERT,(a0)+   ; Alert-Box pinseln
          move.w    #1,(a0)+
          move.w    #1,(a0)+
          move.w    #1,(a0)+
          move.w    #0,(a0)+
          lea       int_in,a0           ; Adresse des int_in-Arrays
          move.w    d0,(a0)             ; int_in(0) = Default-Button
          lea       addr_in,a0          ; Adresse des addr_in-Arrays 
          move.l    a1,(a0)             ; addr_in(0) = String
          bsr       aes
          lea       int_out,a0
          move.w    (a0),d0             ; gedrckter Knopf in d0
          movem.l   (sp)+,a0-a1
          rts

*+
*     Form des Mauszeigers setzen:
*         D0.W: Nummer der Mausform (0..7)
*-
mouse_form:
          move.l    a0,-(sp)
          lea       control,a0  
          move.w    #GRAF_MOUSE,(a0)+
          move.w    #1,(a0)+
          move.w    #1,(a0)+
          move.w    #1,(a0)+
          move.w    #0,(a0)+
          lea       int_in,a0
          move      d0,(a0)             ; Nummer der Mausform
          bsr       aes
          move.l    (sp)+,a0
          rts 

*+
*     Daten
*-
          data

menu_id   dc.w      0

          even
string:   dc.b      '[1]'
          dc.b      '[|Harddisk parken ?]'
          dc.b      '[JA|ABBRUCH]'

          even
goodbye:  dc.b      '[0]'
          dc.b      '[|Kpfe auf Parkspur gebracht,|Sie drfen ausschalten !|]'
          dc.b      '[DESKTOP]'
          
          even
ac_str:   dc.b      "  Harddisk parken"
          dc.b      0
          
          even
AESPB:    dc.l      control             ; AES Parameter Block
          dc.l      global
          dc.l      int_in
          dc.l      int_out
          dc.l      addr_in
          dc.l      addr_out
              
          even
global:   
ap_vers:  dc.w      0
ap_count: dc.w      0
ap_id:    dc.w      0
ap_priv:  dc.l      3570
ap_ptree: dc.l      0
ap_1res:  dc.l      0
ap2_res:  dc.l      0
ap3_res:  dc.l      0
ap4_res:  dc.l      0

          bss
msgbuf:   ds.w      8                   ; msgbuffer[8]          
control:  ds.w      10                  ; cntrl[10]
int_in:   ds.w      128                 ; int_in[128]
int_out:  ds.w      128                 ; int_out[128]
addr_in:  ds.l      128                 ; addr_in[128]
addr_out: ds.l      128                 ; addr_out[128]

buffer    ds.b      512
          ds.b      $100                ; Platz fr Stack
base:     ds.w      1
          
          end     
