*+
*       park.s                                              Achim Freimann
*
*         Parkprogramm fr Festplatte an PC/XT-Kontroller
*         Mu mit 'hdbios' gelinkt werden!
*
*         Da der Parkzylinder i.d.R. nicht innerhalb der Datenzylinder
*         liegt, wird fr den Positioniervorgang der Kontroller neu
*         initalisiert. Ohne diese Aktivitt wrden nur Seek-Kommandos 
*         erfat, die sich in den Grenzen der letzten Initialisierung 
*         bewegen. 
*         Anschlieend wird auf den 'NOT-AUS'-Schalter gewartet.
*         (Notausstieg durch ^c)
*
*         Die Zugriffe auf den DMA-Chip stren brigens nicht. Sie werden
*         nur fr die Variante am DMA-Port bentigt.
*         Die (neu hinzugekommene) Umschaltung des RomPortEXpanders sollte
*         auch unsere DMA-Fans nicht verwirren! Strt nmlich auch nicht!
*
*         16.01.88   af   v1.0  - Funktioniert schon !
*         16.01.88   af   v1.1  - Etwas Gute-Nacht-Stimmung erzeugen
*         10.03.88   af   v1.2  - Untersttzung fr RomPortEXpander
*         16.03.88   af   v1.3  - Abbruchmeldung nach Lesefehler ausgeben
*-

gemdos    equ     1
cconin    equ     1                   ; Zeicheneingabe mit warten
crawcin   equ     7                   ; Zeicheneingabe ohne Echo
cconws    equ     9
cconis    equ     $b
pterm     equ     $4c
bios      equ     13
bconout   equ     3
xbios     equ     14
random    equ     17
_seek     equ     $0b                 ; Laufwerk positionieren
steprate  equ     1                   ; wie in 'hdbios' und 'cbind'

flock     equ     $43e                ; zum Sperren von FDC-Aktionen
diskctl   equ     $ffff8604           ; Kontrollerzugriff / Sektorzhler
fifo      equ     $ffff8606           ; DMA-Steuerregister

          xref    super_on
          xref    superoff
          xref    hd_read
          xref    hd_init
          xref    send_cmd
          xref    status
          xref    wait_l

          text
          page
*+
*       Hier wird's gemacht !
*-
park_cyl  set     $1b8                ; Zeiger auf Wert der Parkspur
drv_parm  set     $1ba                ; Zeiger auf Plattenparameter
*
park      jsr     super_on            ; echt Super !
          bsr     readboot
          lea     buffer,a5

*       Klappe auf ...
          move    drv_parm(a5),-(sp)  ; max. Anzahl der Zyl. merken ... 
          move    park_cyl(a5),d0
          addq    #1,d0               ; Anzahl der Zyl. = Parkzyl. + 1
          move    d0,drv_parm(a5)
          pea     drv_parm(a5)
          jsr     hd_init
          addq.l  #4,sp

*       ... Kopf rein ...
          clr.l   -(sp)
          move    park_cyl(a5),2(sp)  ; dies ist endlich der Parkzylinder
          bsr     hd_seek             ; nichts wie hin !
          addq.l  #4,sp

*       ... Klappe zu !
          move    (sp)+,drv_parm(a5)  ; ... hier wird's wieder benutzt
          pea     drv_parm(a5)
          jsr     hd_init
          addq.l  #4,sp

          jsr     superoff
          bsr     swap_col
          bsr     message
forever   bsr     stars
          move    #cconis,-(sp)
          trap    #gemdos
          addq.l  #2,sp
          tst     d0
          beq     forever

          move    #crawcin,-(sp)      ; Tastatureingabe ohne Warten
          trap    #gemdos
          addq.l  #2,sp
          cmp.b   #3,d0               ; ^c ?
          bne     forever

          bsr     swap_col
          bsr     message2
exit      clr     -(sp)
          move    #pterm,-(sp)
          trap    #gemdos             ; doch noch den Absprung wagen !

          page
*+
*       Kleinere Unterprogramme
*-

*       Bootsektor in Buffer laden

readboot  clr.l   -(sp)
          move    #1,-(sp)            ; Blockzhler
          pea     buffer
          clr     -(sp)
          jsr     hd_read
          lea     12(sp),sp
          tst     d0                  ; Fehler aufgetreten
          bne     abort               ; Fehlermeldung ausgeben
          rts

abort     addq.l  #4,sp               ; Rcksprungadresse vernichten

          pea     err_msg
          move    #cconws,-(sp)       ; Meldung ausgeben
          trap    #gemdos
          addq.l  #6,sp

          move    #cconin,-(sp)       ; auf Tastendruck warten
          trap    #gemdos
          addq.l  #4,sp

          move    #-1,-(sp)           ; Fehlernummer
          move    #pterm,-(sp)        ; Prg. beenden
          trap    #gemdos


*       Etwas Text auf die Glotze bringen

message   pea     park_msg
          move    #cconws,-(sp)
          trap    #gemdos
          addq.l  #6,sp
          rts

message2  pea     ret_msg
          move    #cconws,-(sp)
          trap    #gemdos
          addq.l  #6,sp
          rts

*       Jetzt kommt etwas Bewegung in die Flimmerkiste !

stars     move    #random,-(sp)       ; was fr'n Zufall !
          trap    #xbios
          addq.l  #2,sp
          lea     star,a3
          move    d0,d1
          lsr     #5,d1
          and.b   #$3f,d1
          add.b   #40,d1
          move.b  d1,3(a3)            ; Spalte
          swap    d1
          and     #$7,d1
          add.b   #35,d1
          move.b  d1,2(a3)            ; Zeile
          and     #$f,d0
          move.b   6(a3,d0),4(a3)     ; Muster

          move    #4,d4
prt_star  clr     -(sp)
          move.b  (a3)+,1(sp)
          move    #2,-(sp)
          move    #bconout,-(sp)
          trap    #bios
          addq.l  #6,sp
          dbra    d4,prt_star
          rts

*       Vorder- & Hintergrundfarbe vertauschen (brutale Methode, aber einfach)

col_regs  equ     $ff8240
swap_col  jsr     super_on
          move    col_regs,d0
          move    col_regs+2,col_regs
          move    d0,col_regs+2
          jsr     superoff
          rts

          page
*+
*       Laufwerk auf Spur positionieren
*
*         hd_seek(cyl)
*           long cyl
*-
cyl       set     10                  ; ist unteres Wort !
*
hd_seek   link    a6,#0
          movem.l d1-d3/a4-a5,-(sp)
          bsr     slot_on             ; Rom-Port auf PC-Adapter 
          lea     diskctl,a5
          lea     fifo,a4
          st      flock               ; Floppy VBL sperren

          move    cyl(a6),d0
          move    #steprate,-(sp)
          clr     -(sp)               ; Blockzhler
          clr.l   -(sp)
          move.b  d0,3(sp)            ; Cyl. %%7 - %%0
          clr.b   d0
          lsr     #2,d0
          move.b  d0,1(sp)            ; Cyl. %%9 - %%8
          clr     -(sp)
          move    #_seek,-(sp)
          bsr     send_cmd
          add.l   #12,sp
          move.l  #2000,d1            ; 10 Sek. timeout
          bsr     wait_l
          bsr     status              ; Statusbyte lesen

seek_err  move    #$80,(a4)           ; DMA wieder auf Floppy
          sf      flock               ; Floppy VBL freigeben
          bsr     slot_off            ; alten Rom-Port selektieren
          movem.l (sp)+,d1-d3/a4-a5
          unlk    a6
          rts

          page

*+
*       Rom-Port auf Slot 1, Platine 1 (um)schalten
*-
slot_on   movem.l d0/a0,-(sp)
          lea     $fbfff0,a0          ; Basisadresse RPEX
          tst.b   $e(a0)              ; 3 mal $fbfffe lesen
          tst.b   $e(a0)
          tst.b   $e(a0)              ; Sesam ffne dich !!
          move.b  $8(a0),d0           ; aktuellen Slot holen
          and     #3,d0                 
          eor     #3,d0               ; wg. invertierter Logik
          move    d0,slot_nr          ; reale Slotnr. merken
          tst.b   (a0)                ; Slot 1, Platine 1 selektieren
          movem.l (sp)+,d0/a0
          rts

*+
*       alten Rom-Port selektieren
*-
slot_off  movem.l d0/a0,-(sp)
          lea     $fbfff0,a0          ; Basisadresse RPEX
          tst.b   $e(a0)              ; 3 mal $fbfffe lesen
          tst.b   $e(a0)
          tst.b   $e(a0)              ; Sesam ffne dich !!
          tst.b   $8(a0)              ; Dummyzugriff (Slotnr. lesen)
          move    slot_nr,d0
          lsl     #1,d0               ; Slot-Nr. --> gerade Adresse
          tst.b   0(a0,d0)            ; Slot whlen
          movem.l (sp)+,d0/a0
          rts

          page
*+
*       Text und andere Sachen
*-
tab       equ     9
lf        equ     10
cr        equ     13
esc       equ     27
crsr_up   equ     $1b41               ; esc 'A'

          data
err_msg   dc.b    cr,lf,tab,'Fehler beim Parkvorgang !!'
          dc.b    cr,lf,tab,'Abbruch durch Tastendruck. ',0

          even
star      dc.b    esc,'Y',0,0,0,0
          dc.b    '      *         '
park_msg  dcb.b   50,lf
          dc.b    esc,'f'
          dc.b    cr,tab,tab,'PARK-Programm fr Festplatte',lf
          dc.b    cr,tab,tab,'----------------------------',lf,lf
          dc.b    cr,tab,tab,'Guten Abend, gute Nacht, die Platte',lf
          dc.b    cr,tab,tab,'ist auf die Parkspur gebracht !',lf,lf
          dc.b    cr,tab,tab,'Und nun den Griff zum Netzschalter... '
          dcb.b   4,lf
          dc.b    0,0

          even
ret_msg   dcb.b   50,lf
          dc.b    esc,'e',0,0

          bss
slot_nr   ds.w    1     
buffer    ds.b    512

